Index: src/newlib/ChangeLog
diff -u src/newlib/ChangeLog:1.733 src/newlib/ChangeLog:1.779
--- src/newlib/ChangeLog:1.733	Fri Dec 17 20:17:12 2004
+++ src/newlib/ChangeLog	Thu Apr 28 18:26:07 2005
@@ -1,3 +1,371 @@
+2005-04-28  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/stdio/vfscanf.c (__svfscanf_r): Fix code thinko
+	when checking for multiple flags.
+
+2005-04-18  Hans-Peter Nilsson  <hp@axis.com>
+
+	* configure.host <cris-*-* | crisv32-*-*>: Set
+        default_newlib_io_long_long="yes".
+
+2005-04-08  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/include/libgen.h: New file.
+
+2005-04-08  Shaun Jackman  <sjackman@gmail.com>
+
+	* libc/unix/Makefile.am: Add support for basename and dirname.
+	* libc/unix/Makefile.in: Regenerated.
+	* libc/unix/basename.c: New file.
+	* libc/unix/dirname.c: New file.
+
+2005-04-07  Shaun Jackman  <sjackman@gmail.com>
+
+	* libc/sys/linux/inode.c (lchown): New function.
+
+2005-04-07  Shaun Jackman  <sjackman@gmail.com>
+
+	* libc/unix/Makefile.am (LIB_OBJS): Include all the ELIX objects if no
+	ELIX level is defined.
+	* libc/unix/Makefile.in: Regenerated.
+
+2005-04-05  Dave Korn  <dave.korn@artimi.com>
+
+	* libc/stdio/vfscanf.c (__svfscanf_r): If an error occurs processing
+	something that looks like a "NaN", put back the characters processed.
+
+2005-04-01  Corinna Vinschen  <corinna@vinschen.de>
+
+	* libc/stdlib/strtod.c (_strtod_r): Never change s00.
+
+2005-03-23  Christopher Faylor  <cgf@timesys.com>
+
+	* configure.host: For cygwin, redefine CC with cygwin include directory
+	first to mimic the behavior of the top-level configury.  Move include
+	directory out of newlib_cflags.
+
+2005-03-22  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* configure.host: For arc, set -DREENTRANT_SYSCALLS_PROVIDED flag on.
+	* libc/sys/arc/syscalls.c: Change functions to use __errno_r rather 
+	than errno.
+
+2005-03-22  Christopher Faylor  <cgf@timesys.com>
+
+	* libc/include/machine/_types.h: Make trivial change to comment to
+	avoid a spurious warning from gcc.
+
+2005-03-21  Nicholas Wourms  <nwourms@netscape.net>
+
+	* libc/stdio/vfprintf.c: Move newlib.h before _WANT_IO_POS_ARGS test,
+	since _WANT_IO_POS_ARGS is now defined in there.  Remove duplicate
+	reent.h include.
+
+2005-03-18  Hans-Peter Nilsson  <hp@axis.com>
+            Corinna Vinschen  <corinna@vinschen.de>
+
+        * libc/include/ctype.h: Remove invalid +1 offset from
+        ctype macro references to __ctype_ptr.
+        (_ctype_): Move declaration outside #ifndef __cplusplus.
+
+2005-03-18  Corinna Vinschen  <corinna@vinschen.de>
+
+	* libc/include/machine/setjmp.h (sigsetjmp): Use GCC extension to
+	evaluate first parameter only once.
+	(siglongjmp): Ditto.
+
+2005-03-17  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* configure.in: Add new check to see if compiler supports
+	aliasing of arrays and define _HAVE_ARRAY_ALIASING if true.
+	* configure: Regenerated.
+	* Makefile.in: Ditto.
+	* newlib.hin: Add _HAVE_ARRAY_ALIASING.
+	* libc/ctype/ctype_.c: Check for _HAVE_ARRAY_ALIASING before
+	aliasing the _ctype_ array to _ctype_b.
+	* libc/include/ctype.h: Change macros to use __ctype_ptr.  Mark
+	_ctype_ as deprecated.
+
+2005-03-17  Hans-Peter Nilsson  <hp@axis.com>
+
+	* configure.host (newlib_cflags) <cris-*-*, crisv32-*-*>: Add
+	-DCOMPACT_CTYPE.
+
+2005-03-06  Ralf Corsepious  <ralf.corsepius@rtems.org>
+
+	* libc/sys/rtems/include/inttypes.h: New file.
+	* libc/sys/rtems/include/stdint.h: Ditto.
+
+2005-03-06  Ralf Corsepious  <ralf.corsepius@rtems.org>
+
+	* libc/string/memcmp.c: Fix to avoid pointer signedness warning.
+
+2005-03-06  Ralf Corsepious  <ralf.corsepius@rtems.org>
+
+	* libc/include/machine/_types.h: New file.
+	* libc/include/sys/types.h: Do not check for __rtems__
+	when including <machine/_types.h>.  Remove some redundant
+	declarations now that <machine/_types.h> is included.
+	* libc/sys/rtems/machine/_types.h: Removed.  Replaced with
+	shared header file.
+
+2005-02-25  Ralf Corsepious  <ralf.corsepius@rtems.org>
+
+	* libm/common/fdlibm.h (FLT_UWORD_MAX, FLT_UWORD_HALF_MAX): Add
+	L qualifier for these long constants.
+
+2005-02-25  Eric Blake  <ebb9@byu.net>
+
+	* libc/include/time.h (__tzrule_struct): Make offset long, since
+	a 16-bit int overflows on a 12-hour offset.
+	* libc/sys/linux/include/time.h: Ditto.
+	* libc/time/mktime.c (mktime): Use new type of __tzrule.offset.
+	* libc/time/mktm_r.c: Ditto.
+	* libc/time/gettzinfo.c: Ditto.
+	* libc/time/strftime.c (strftime): Fix '%x' to deal with negative
+	years.  Fix '%z' to use long, not int.
+
+2005-02-24  Ralf Corsepious  <ralf.corsepius@rtems.org>
+
+	* libm/common/s_fpclassify.c: Use __uint32_t instead of int to
+	manipulate float values in integer form.
+	* libm/common/sf_round.c: Ditto.
+
+2005-02-24  Ralf Corsepious  <ralf.corsepius@rtems.org>
+
+	* libc/include/sys/types.h [__rtems__]: Include new
+	header file machine/_types.h.
+	* libc/include/machine/types.h: Ditto.
+	* libc/sys/rtems/machine/_types.h: New file.
+
+2005-02-23  Corinna Vinschen  <corinna@vinschen.de>
+
+	* libc/include/time.h (_timezone): Change to long also for Cygwin.
+	(timezone): Drop cast from definition.
+
+2005-02-23  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/include/time.h [!CYGWIN](_timezone): Change to long.
+	(__tzrule_type, __tzinfo_type): New types.
+	(__gettzinfo): New function.
+	* libc/sys/linux/include/time.h: Ditto.
+	* libc/time/Makefile.am: Add gettzinfo.c.
+	* libc/time/Makefile.in: Regenerated.
+	* libc/time/local.h: Moved __tzrule_type to time.h.
+	* libc/time/mktime.c: Call __gettzinfo to reference
+	__tznorth, __tzyear, and __tzrule array.
+	* libc/time/mktm_r.c: Ditto.
+	* libc/time/strftime.c: Ditto.
+	* libc/time/tzset_r.c: Ditto.  Also remove definition
+	of __tzrule which is now in gettzinfo.c.  Change _timezone
+	references to not cast to time_t.
+	* libc/time/gettzinfo.c: New file.
+
+2005-02-23  Corinna Vinschen  <corinna@vinschen.de>
+
+	* libc/include/sys/unistd.h: Define getpeereid for Cygwin.
+
+2005-02-22  Corinna Vinschen  <corinna@vinschen.de>
+
+	* libc/include/sys/unistd.h: Define fdatasync also for Cygwin.
+
+2005-02-16  Eric Blake  <ebb9@byu.net>
+
+	* libc/time/time.tex: Improve the documentation.
+	* libc/time/strftime.c: Improve the documentation.
+	(iso_year_adjust): New helper function.
+	(strftime): Simplify '%E' and '%O'. Change '%c' to use
+	recursion. Fix '%C', '%y', and '%Y' to deal with years with more
+	than 4 characters.  Combine '%d' and '%e'. Implement '%D', '%F',
+	'%g', '%G', '%n', '%R', '%t', '%T', '%u', '%V', '%X', and '%z'.
+	Avoid core dumps on valid inputs (maxsize == 0, or
+	tim_p->tm_isdst > 1).
+
+2005-02-08  Corinna Vinschen  <corinna@vinschen.de>
+
+	* libc/include/pwd.h (struct passwd): Change pw_uid and pw_gid
+	members to uid_t and gid_t according to SUSv3.
+	* libc/include/sys/time.h (utimes):  Change second parameter
+	to const according to SUSv3.
+
+2005-02-07  Antony King  <antony.king@st.com>
+
+	* libc/stdio/clearerr.c (clearerr): Ensure CHECK_INIT() is
+	called before _flockfile to prevent lock object use before
+	initialisation. _REENT_SMALL_CHECK_INIT() and CHECK_INIT()
+	take a struct _reent * instead of a FILE *.
+	* libc/stdio/fclose.c (_fclose_r): Ditto.
+	* libc/stdio/feof.c (feof): Ditto.
+	* libc/stdio/ferror.c (ferror): Ditto.
+	* libc/stdio/fflush.c (fflush): Ditto.
+	* libc/stdio/fgetc.c (fgetc): Ditto.
+	* libc/stdio/fgets.c (fgets): Ditto.
+	* libc/stdio/fileno.c (fileno): Ditto.
+	* libc/stdio/fputc.c (fputc): Ditto.
+	* libc/stdio/fputs.c (fputs): Ditto.
+	* libc/stdio/fread.c (fread): Ditto.
+	* libc/stdio/freopen.c (_freopen_r): Ditto.
+	* libc/stdio/fseek.c (_fseek_r): Ditto.
+	* libc/stdio/ftell.c (_ftell_r): Ditto.
+	* libc/stdio/fwrite.c (fwrite): Ditto.
+	* libc/stdio/getc.c (getc): Ditto.
+	* libc/stdio/getdelim.c (__getdelim): Ditto.
+	* libc/stdio/putc.c (putc): Ditto.
+	* libc/stdio/setvbuf.c (setvbuf): Ditto.
+	* libc/stdio/ungetc.c (_ungetc_r): Ditto.
+	* libc/stdio/vfprintf.c (_VFPRINTF_R): Ditto.
+	* libc/stdio64/freopen64.c (_freopen64_r): Ditto.
+	* libc/stdio64/fseeko64.c (_fseeko64_r): Ditto.
+	* libc/stdio64/ftello64.c (_ftello64_r): Ditto.
+	* libc/stdio/local.h (CHECK_INIT): Argument is now a struct
+	_reent * instead of a FILE * and so replace incorrect use of
+	_REENT with argument.
+	* libc/sys/arm/syscalls.c (CHECK_INIT): Ditto.
+	* libc/stdio/getchar.c (getchar): _REENT_SMALL_CHECK_INIT() and
+	CHECK_INIT() take a struct _reent * instead of a FILE *.
+	* libc/stdio/iprintf.c (iprintf, _iprintf_r): Ditto.
+	* libc/stdio/iscanf.c (iscanf, _iscanf_r): Ditto.
+	* libc/stdio/perror.c (perror): Ditto.
+	* libc/stdio/printf.c (printf, _printf_r): Ditto.
+	* libc/stdio/putchar.c (putchar): Ditto.
+	* libc/stdio/puts.c (puts): Ditto.
+	* libc/stdio/refill.c (__srefill): Ditto.
+	* libc/stdio/scanf.c (scanf, _scanf_r): Ditto.
+	* libc/stdio/vfscanf.c (VFSCANF, _VFSCANF_R): Ditto.
+	* libc/stdio/viprintf.c (viprintf, _viprintf_r): Ditto.
+	* libc/stdio/viscanf.c (viscanf, _viscanf_r): Ditto.
+	* libc/stdio/vprintf.c (vprintf, _vprintf_r): Ditto.
+	* libc/stdio/vscanf.c (vscanf, _vscanf_r): Ditto.
+	* libc/stdio/wbuf.c (__swbuf): Ditto.
+	* libc/stdio/wsetup.c (__swsetup): Ditto.
+	* libc/stdlib/mallocr.c (malloc_stats): Ditto.
+	* libc/stdlib/mstats.c (_mstats_r): Ditto.
+	* libc/include/sys/reent.h (_REENT_SMALL_CHECK_INIT): Ditto.
+	* libc/machine/powerpc/vfscanf.c (vfscanf): Ditto.
+	* libc/stdio/fgetpos.c (_fgetpos_r): Removed unnecessary calls
+	to _flockfile and _funlockfile; rely on locking in _ftell_r.
+	* libc/stdio64/fgetpos64.c (_fgetpos64_r): Ditto (_ftello64_r).
+	* libc/machine/powerpc/vfprintf.c (__sbprintf): Removed unnecessary
+	initialision of _data field in FILE structure.
+	* libc/machine/powerpc/vfprintf.c (VFPRINTF): Added CHECK_INIT() call.
+
+2005-02-07  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/stdio/findfp.c (__sinit): Protect with new lock.
+	(__sinit_lock): New lock.
+	(__sinit_lock_acquire, __sinit_lock_release): New functions.
+	* libc/stdio/local.h: Add reference to new __sinit locking
+	functions.
+
+2005-02-07  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/include/math.h (isfinite, isnormal, isunordered): Change
+	input variable names to avoid mixups with nesting macros.
+
+2005-01-27  Hans-Peter Nilsson  <hp@axis.com>
+
+	* configure.host: Add support for cris-*-* and crisv32-*-*.
+	* libc/include/machine/ieeefp.h: Ditto.
+	* libc/include/machine/setjmp.h: Ditto.
+	* libc/machine/cris/configure.in, libc/machine/cris/Makefile.am,
+	libc/machine/cris/libcdtor.c, libc/machine/cris/setjmp.c,
+	libc/machine/cris/memmove.c, libc/machine/cris/memcpy.c,
+	libc/machine/cris/memset.c, libc/machine/cris/include/pthread.h,
+	libc/machine/cris/sys/signal.h, libc/machine/cris/sys/fcntl.h,
+	libc/machine/cris/sys/errno.h, libc/machine/cris/aclocal.m4,
+	libc/machine/cris/configure, libc/machine/cris/Makefile.in: New
+	files.
+
+2005-01-27  Hans-Peter Nilsson  <hp@axis.com>
+
+	* testsuite/newlib.string/memmove1.c: New test.
+
+2005-01-27  Hans-Peter Nilsson  <hp@axis.com>
+
+	* testsuite/include/check.h: Include stdlib.h.
+
+2005-01-27  Hans-Peter Nilsson  <hp@axis.com>
+
+	* Makefile.am (stmp-targ-include): Support include header files
+	from machine directories.
+	(install-data-local): Ditto.
+	* Makefile.in: Regenerate.
+
+2005-01-24  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/include/string.h: Remove Linux-specific declaration of
+	strsignal and add #include <sys/string.h>.
+	* libc/include/sys/string.h: New file.
+	* libc/include/sys/linux/sys/string.h: New file with strsignal
+	declaration deleted above.
+
+2005-01-20  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/time/strftime.c (strftime): Change %r and %x to be compliant
+	to POSIX standard for "C" locale.  Allow %E and %O modifiers
+	to be ignored as long as they precede valid specifiers according
+	to POSIX.
+
+2005-01-19  Shaun Jackman  <sjackman@gmail.com>
+
+	* libc/stdlib/setenv_r.c (_setenv_r): Call tzset() if the TZ
+	environment variable is set.
+
+2005-01-19  Shaun Jackman  <sjackman@gmail.com>
+
+        * tzset_r.c (_tzname): Add a comma.
+
+2005-01-18  Aldy Hernandez  <aldyh@redhat.com>
+
+	* libc/machine/powerpc/vfprintf.c: Use _REENT when calling
+	_VFPRINTF_R.
+
+2005-01-07  Paul Brook  <paul@codesourcery.com>
+                                                                                
+	* configure.in: Add test for .init_array.
+	* configure: Regenerate.
+	* newlib.hin: Add HAVE_INITFINI_ARRAY.
+	* libc/misc/Makefile.am: Add init.c
+	* libc/misc/Makefile.in: Regenerate.
+	* libc/misc/init.c: New file.
+	* libc/sys/arm/crt0.S: Call __libc_{init,fini}_array instead of
+	_init/_fini if they exist.
+                                                                                
+2005-01-06  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/stdlib/strtod.c (_strtod_r): Add NaN support.
+	* (strtof): Ditto.
+	* libc/stdio/vfscanf.c (__svfscanf_r): Ditto.
+	* Makefile.am (MATHOBJS_IN_LIBC): Add s_nan and sf_nan
+	functions for use by strtod and strtof.
+	* Makefile.in: Regenerated.
+                                                                                
+2005-01-06  Hans-Peter Nilsson  <hp@axis.com>
+                                                                                
+	* libc/stdio/ftell.c (ftell_r): Add parenthesis for __SWR
+	bit-test in combination with NULL test.
+                                                                                
+2005-01-06  Hans-Peter Nilsson  <hp@axis.com>
+                                                                                
+        * README: Fix typo of LGPL.  Change "license" to "copyright".
+                                                                                
+2004-12-17  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* NEWS: Update with 1.13.0 info.
+	* README: Ditto.
+	* acinclude.m4: Change version number to 1.13.0.
+	* aclocal.m4: Regenerated.
+	* configure: Ditto.
+	* doc/aclocal.m4: Ditto.
+	* doc/configure: Ditto.
+	* libc/*/aclocal.m4: Ditto.
+	* libc/*/configure: Ditto.
+	* libc/libc.texinfo: Ditto.
+	* libm/*/aclocal.m4: Ditto.
+	* libm/*/configure: Ditto.
+	* libm/libm.texinfo: Ditto.
+	* libc/sys/linux/shared.ld: Add VERS_1.13.
+
 2004-12-17  Christian Groessler  <chris@groessler.org>
 
 	* libc/machine/z8k/memcmp.S: New file.
Index: src/newlib/Makefile.am
diff -u src/newlib/Makefile.am:1.31 src/newlib/Makefile.am:1.33
--- src/newlib/Makefile.am:1.31	Fri Dec  3 23:46:28 2004
+++ src/newlib/Makefile.am	Thu Jan 27 19:13:54 2005
@@ -89,6 +89,7 @@
 MATHOBJS_IN_LIBC = \
 	s_isinf.$(oext) sf_isinf.$(oext) \
 	s_isnan.$(oext) sf_isnan.$(oext) \
+	s_nan.$(oext) sf_nan.$(oext) \
 	s_ldexp.$(oext) sf_ldexp.$(oext) \
 	s_frexp.$(oext) sf_frexp.$(oext) \
 	s_modf.$(oext) \
@@ -200,6 +201,11 @@
 	      cp $$i targ-include/sys/`basename $$i`; \
 	    else true; fi ; \
 	  done
+	-for i in $(srcdir)/libc/machine/$(machine_dir)/include/*.h; do \
+	    if [ -f $$i ]; then \
+	      cp $$i targ-include/`basename $$i`; \
+	    else true; fi ; \
+	  done
 	-for i in $(srcdir)/libc/sys/$(sys_dir)/include/*.h; do \
 	    if [ -f $$i ]; then \
 	      cp $$i targ-include/`basename $$i`; \
@@ -260,6 +266,11 @@
 	     $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/sys/`basename $$i`; \
 	    else true; fi ; \
 	  done ; \
+	  for i in $(srcdir)/libc/machine/$(machine_dir)/include/*.h; do \
+	    if [ -f $$i ]; then \
+	     $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/`basename $$i`; \
+	    else true; fi ; \
+	  done ; \
 	  for i in $(srcdir)/libc/sys/$(sys_dir)/sys/*.h; do \
 	    if [ -f $$i ]; then \
 	     $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/sys/`basename $$i`; \
Index: src/newlib/README
diff -u src/newlib/README:1.11 src/newlib/README:1.13
--- src/newlib/README:1.11	Fri Dec 17 22:47:49 2004
+++ src/newlib/README	Mon Jan 10 16:24:12 2005
@@ -5,9 +5,9 @@
 of board support packages.
 
 The newlib and libgloss subdirectories are a collection of software from
-several sources, each with their own copyright.  See the file COPYING.NEWLIB
-for details.  The rest of the release tree is under either the GNU GPL or
-LPGL copyright.
+several sources, each with their own copyright and license.  See the file
+COPYING.NEWLIB for details.  The rest of the release tree is under either
+the GNU GPL or LGPL licenses.
 
 THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
Index: src/newlib/configure.host
diff -u src/newlib/configure.host:1.66 src/newlib/configure.host:1.72
--- src/newlib/configure.host:1.66	Tue Oct  5 19:44:24 2004
+++ src/newlib/configure.host	Mon Apr 18 02:52:21 2005
@@ -93,6 +93,9 @@
   avr*)
 	newlib_cflags="${newlib_cflags} -DPREFER_SIZE_OVER_SPEED -mcall-prologues"
 	;;
+  cris | crisv32)
+	machine_dir=cris
+	;;
   crx*)
 	machine_dir=crx
 	;;
@@ -452,7 +455,8 @@
 	default_newlib_io_long_long="yes"
 	default_newlib_io_long_double="yes"
 	default_newlib_io_pos_args="yes"
-	newlib_cflags="${newlib_cflags} -DHAVE_OPENDIR -DHAVE_RENAME -DSIGNAL_PROVIDED -D_COMPILING_NEWLIB -DHAVE_FCNTL -DMALLOC_PROVIDED -I${cygwin_srcdir}/include"
+	CC="${CC} -I${cygwin_srcdir}/include"
+	newlib_cflags="${newlib_cflags} -DHAVE_OPENDIR -DHAVE_RENAME -DSIGNAL_PROVIDED -D_COMPILING_NEWLIB -DHAVE_FCNTL -DMALLOC_PROVIDED"
 	syscall_dir=syscalls
 	;;
 # RTEMS supplies its own versions of some routines:
@@ -499,11 +503,19 @@
 	  newlib_cflags="${newlib_cflags} -DARM_RDI_MONITOR"
 	fi
 	;;
+  arc*)
+	newlib_cflags="${newlib_cflags} -DREENTRANT_SYSCALLS_PROVIDED"
+	;;
   avr*)
 	newlib_cflags="${newlib_cflags} -DNO_EXEC -DSMALL_MEMORY -DMISSING_SYSCALL_NAMES"
 	;;
+  cris-*-* | crisv32-*-*)
+	default_newlib_io_long_long="yes"
+	newlib_cflags="${newlib_cflags} -DHAVE_RENAME -DHAVE_GETTIMEOFDAY -D_USE_WRITE -DCOMPACT_CTYPE"
+	syscall_dir=syscalls
+	;;
   crx-*-*)
-  	newlib_cflags="${newlib_cflags} -DHAVE_RENAME -DMISSING_SYSCALL_NAMES"
+	newlib_cflags="${newlib_cflags} -DHAVE_RENAME -DMISSING_SYSCALL_NAMES"
 	syscall_dir=
 	;;
   d10v*)
Index: src/newlib/configure.in
diff -u src/newlib/configure.in:1.25 src/newlib/configure.in:1.27
--- src/newlib/configure.in:1.25	Wed Sep 15 20:50:06 2004
+++ src/newlib/configure.in	Thu Mar 17 20:11:17 2005
@@ -329,6 +329,50 @@
   done
 fi;
 
+AC_CACHE_CHECK(for .preinit_array/.init_array/.fini_array support,
+	       libc_cv_initfinit_array, [dnl
+cat > conftest.c <<EOF
+int _start (void) { return 0; }
+int __start (void) { return 0; }
+int foo (void) { return 1; }
+int (*fp) (void) __attribute__ ((section (".init_array"))) = foo;
+EOF
+if AC_TRY_COMMAND([${CC} $CFLAGS $CPPFLAGS $LDFLAGS -o conftest conftest.c
+		   -static -nostartfiles -nostdlib 1>&AS_MESSAGE_LOG_FD])
+then
+  if readelf -S conftest | grep -e INIT_ARRAY > /dev/null; then
+    libc_cv_initfinit_array=yes
+  else
+    libc_cv_initfinit_array=no
+  fi
+else
+  libc_cv_initfinit_array=no
+fi
+rm -f conftest*])
+AC_SUBST(libc_cv_initfinit_array)
+if test $libc_cv_initfinit_array = yes; then
+  AC_DEFINE_UNQUOTED(HAVE_INITFINI_ARRAY)
+fi
+
+AC_CACHE_CHECK(for array aliasing support,
+	       libc_cv_array_aliasing, [dnl
+cat > conftest.c <<EOF
+char x[3] = { 'a', 'b', 'c' };
+extern char y[2] __attribute__((alias ("x+1")));
+EOF
+if AC_TRY_COMMAND([${CC} $CFLAGS $CPPFLAGS -c conftest.c
+		   1>&AS_MESSAGE_LOG_FD])
+then
+  libc_cv_array_aliasing=yes
+else
+  libc_cv_array_aliasing=no
+fi
+rm -f conftest*])
+AC_SUBST(libc_cv_array_aliasing)
+if test $libc_cv_array_aliasing = yes; then
+  AC_DEFINE_UNQUOTED(_HAVE_ARRAY_ALIASING)
+fi
+
 AC_OUTPUT(Makefile,
 [if test -n "$CONFIG_FILES"; then
   unset ac_file
Index: src/newlib/newlib.hin
diff -u src/newlib/newlib.hin:1.7 src/newlib/newlib.hin:1.9
--- src/newlib/newlib.hin:1.7	Fri Jun 25 20:32:31 2004
+++ src/newlib/newlib.hin	Thu Mar 17 20:11:17 2005
@@ -137,5 +137,12 @@
 #undef _ICONV_FROM_ENCODING_WIN_1257
 #undef _ICONV_FROM_ENCODING_WIN_1258
 
+/* Define if the linker supports .preinit_array/.init_array/.fini_array
+ * sections.  */
+#undef  HAVE_INITFINI_ARRAY
+
+/* Define if the compiler supports aliasing an array to an address.  */
+#undef  _HAVE_ARRAY_ALIASING
+
 #endif /* !__NEWLIB_H__ */
 
Index: src/newlib/libc/ctype/ctype_.c
diff -u src/newlib/libc/ctype/ctype_.c:1.3 src/newlib/libc/ctype/ctype_.c:1.4
--- src/newlib/libc/ctype/ctype_.c:1.3	Tue May 13 09:46:47 2003
+++ src/newlib/libc/ctype/ctype_.c	Thu Mar 17 20:11:22 2005
@@ -84,21 +84,40 @@
 	_CTYPE_DATA_128_256
 };
 
-#if defined(__CYGWIN__)
-extern _CONST char __declspec(dllexport) _ctype_[1 + 256] __attribute__ ((alias ("_ctype_b+127")));
+#  if defined(__CYGWIN__)
 _CONST char __declspec(dllexport) *__ctype_ptr = _ctype_b + 128;
-#else
-extern _CONST char _ctype_[1 + 256] __attribute__ ((alias ("_ctype_b+127")));
+#  else
 _CONST char *__ctype_ptr = _ctype_b + 128;
-#endif
+#  endif
+
+#  if defined(_HAVE_ARRAY_ALIASING)
+
+#    if defined(__CYGWIN__)
+extern _CONST char __declspec(dllexport) _ctype_[1 + 256] __attribute__ ((alias ("_ctype_b+127")));
+#    else
+extern _CONST char _ctype_[1 + 256] __attribute__ ((alias ("_ctype_b+127")));
+#    endif
+
+#  else /* !_HAVE_ARRAY_ALIASING */
+
+#    if defined(__CYGWIN__)
+_CONST char __declspec(dllexport) _ctype_[1 + 256] = {
+#    else
+_CONST char _ctype_[1 + 256] = {
+#    endif
+	0,
+	_CTYPE_DATA_0_127,
+	_CTYPE_DATA_128_256
+};
+#  endif /* !_HAVE_ARRAY_ALIASING */
 
 #else	/* !defined(ALLOW_NEGATIVE_CTYPE_INDEX) */
 
-#if defined(__CYGWIN__)
+# if defined(__CYGWIN__)
 _CONST char __declspec(dllexport) _ctype_[1 + 256] = {
-#else
+# else
 _CONST char _ctype_[1 + 256] = {
-#endif
+# endif
 	0,
 	_CTYPE_DATA_0_127,
 	_CTYPE_DATA_128_256
Index: src/newlib/libc/include/ctype.h
diff -u src/newlib/libc/include/ctype.h:1.7 src/newlib/libc/include/ctype.h:1.9
--- src/newlib/libc/include/ctype.h:1.7	Thu Jun 27 23:58:38 2002
+++ src/newlib/libc/include/ctype.h	Fri Mar 18 17:18:59 2005
@@ -36,20 +36,23 @@
 #define _X	0100
 #define	_B	0200
 
-extern	__IMPORT _CONST char	_ctype_[];
+extern	__IMPORT _CONST char	*__ctype_ptr;
+extern	__IMPORT _CONST char	_ctype_[];  /* For backward compatibility.  */
 
 #ifndef __cplusplus
-#define	isalpha(c)	((_ctype_+1)[(unsigned)(c)]&(_U|_L))
-#define	isupper(c)	((_ctype_+1)[(unsigned)(c)]&_U)
-#define	islower(c)	((_ctype_+1)[(unsigned)(c)]&_L)
-#define	isdigit(c)	((_ctype_+1)[(unsigned)(c)]&_N)
-#define	isxdigit(c)	((_ctype_+1)[(unsigned)(c)]&(_X|_N))
-#define	isspace(c)	((_ctype_+1)[(unsigned)(c)]&_S)
-#define ispunct(c)	((_ctype_+1)[(unsigned)(c)]&_P)
-#define isalnum(c)	((_ctype_+1)[(unsigned)(c)]&(_U|_L|_N))
-#define isprint(c)	((_ctype_+1)[(unsigned)(c)]&(_P|_U|_L|_N|_B))
-#define	isgraph(c)	((_ctype_+1)[(unsigned)(c)]&(_P|_U|_L|_N))
-#define iscntrl(c)	((_ctype_+1)[(unsigned)(c)]&_C)
+#define	isalpha(c)	((__ctype_ptr)[(unsigned)(c)]&(_U|_L))
+#define	isupper(c)	((__ctype_ptr)[(unsigned)(c)]&_U)
+#define	islower(c)	((__ctype_ptr)[(unsigned)(c)]&_L)
+#define	isdigit(c)	((__ctype_ptr)[(unsigned)(c)]&_N)
+#define	isxdigit(c)	((__ctype_ptr)[(unsigned)(c)]&(_X|_N))
+#define	isspace(c)	((__ctype_ptr)[(unsigned)(c)]&_S)
+#define ispunct(c)	((__ctype_ptr)[(unsigned)(c)]&_P)
+#define isalnum(c)	((__ctype_ptr)[(unsigned)(c)]&(_U|_L|_N))
+#define isprint(c)	((__ctype_ptr)[(unsigned)(c)]&(_P|_U|_L|_N|_B))
+#define	isgraph(c)	((__ctype_ptr)[(unsigned)(c)]&(_P|_U|_L|_N))
+#define iscntrl(c)	((__ctype_ptr)[(unsigned)(c)]&_C)
+
+
 /* Non-gcc versions will get the library versions, and will be
    slightly slower */
 #ifdef __GNUC__
Index: src/newlib/libc/include/libgen.h
diff -u /dev/null src/newlib/libc/include/libgen.h:1.1
--- /dev/null	Thu May 12 14:25:15 2005
+++ src/newlib/libc/include/libgen.h	Fri Apr  8 20:48:40 2005
@@ -0,0 +1,23 @@
+/*
+ * libgen.h - defined by XPG4
+ */
+
+#ifndef _LIBGEN_H_
+#define _LIBGEN_H_
+
+#include "_ansi.h"
+#include <sys/reent.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+char      *_EXFUN(basename,     (char *));
+char      *_EXFUN(dirname,     (char *));
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _LIBGEN_H_ */
+
Index: src/newlib/libc/include/math.h
diff -u src/newlib/libc/include/math.h:1.17 src/newlib/libc/include/math.h:1.18
--- src/newlib/libc/include/math.h:1.17	Wed Aug 13 17:36:10 2003
+++ src/newlib/libc/include/math.h	Mon Feb  7 21:04:22 2005
@@ -88,12 +88,12 @@
           (__extension__ ({__typeof__(x) __x = (x); \
                            (sizeof (__x) == sizeof (float))  ? __fpclassifyf(__x) : __fpclassifyd(__x);}))
 
-#define isfinite(x) \
-          (__extension__ ({__typeof__(x) __x = (x); \
-                           fpclassify(__x) != FP_INFINITE && fpclassify(__x) != FP_NAN;}))
-#define isnormal(x) \
-          (__extension__ ({__typeof__(x) __x = (x); \
-                           fpclassify(__x) == FP_NORMAL;}))
+#define isfinite(y) \
+          (__extension__ ({__typeof__(y) __y = (y); \
+                           fpclassify(__y) != FP_INFINITE && fpclassify(__y) != FP_NAN;}))
+#define isnormal(z) \
+          (__extension__ ({__typeof__(z) __z = (z); \
+                           fpclassify(__z) == FP_NORMAL;}))
 #define signbit(x) \
           (__extension__ ({__typeof__(x) __x = (x); \
                            (sizeof(__x) == sizeof(float)) ? __signbitf(__x) : __signbitd(__x);}))
@@ -114,9 +114,9 @@
           (__extension__ ({__typeof__(x) __x = (x); __typeof__(y) __y = (y); \
                            !isunordered(__x,__y) && (__x < __y || __x > __y);}))
 
-#define isunordered(x,y) \
-          (__extension__ ({__typeof__(x) __x = (x); __typeof__(y) __y = (y); \
-                           fpclassify(__x) == FP_NAN || fpclassify(__y) == FP_NAN;}))
+#define isunordered(a,b) \
+          (__extension__ ({__typeof__(a) __a = (a); __typeof__(b) __b = (b); \
+                           fpclassify(__a) == FP_NAN || fpclassify(__b) == FP_NAN;}))
 
 /* Non ANSI double precision functions.  */
 
Index: src/newlib/libc/include/pwd.h
diff -u src/newlib/libc/include/pwd.h:1.2 src/newlib/libc/include/pwd.h:1.3
--- src/newlib/libc/include/pwd.h:1.2	Sun Mar  9 21:08:51 2003
+++ src/newlib/libc/include/pwd.h	Tue Feb  8 20:55:18 2005
@@ -50,8 +50,8 @@
 struct passwd {
 	char	*pw_name;		/* user name */
 	char	*pw_passwd;		/* encrypted password */
-	int	pw_uid;			/* user uid */
-	int	pw_gid;			/* user gid */
+	uid_t	pw_uid;			/* user uid */
+	gid_t	pw_gid;			/* user gid */
 	char	*pw_comment;		/* comment */
 	char	*pw_gecos;		/* Honeywell login info */
 	char	*pw_dir;		/* home directory */
Index: src/newlib/libc/include/string.h
diff -u src/newlib/libc/include/string.h:1.14 src/newlib/libc/include/string.h:1.15
--- src/newlib/libc/include/string.h:1.14	Tue Jul 23 21:38:00 2002
+++ src/newlib/libc/include/string.h	Mon Jan 24 18:46:08 2005
@@ -75,8 +75,6 @@
 const char  *_EXFUN(strsignal, (int __signo));
 #endif
 int     _EXFUN(strtosigno, (const char *__name));
-#elif defined(__linux__)
-char	*_EXFUN(strsignal, (int __signo));
 #endif
 
 /* These function names are used on Windows and perhaps other systems.  */
@@ -95,6 +93,8 @@
 
 #endif /* ! __STRICT_ANSI__ */
 
+#include <sys/string.h>
+
 _END_STD_C
 
 #endif /* _STRING_H_ */
Index: src/newlib/libc/include/time.h
diff -u src/newlib/libc/include/time.h:1.13 src/newlib/libc/include/time.h:1.16
--- src/newlib/libc/include/time.h:1.13	Mon Feb  9 22:56:46 2004
+++ src/newlib/libc/include/time.h	Fri Feb 25 22:31:20 2005
@@ -71,6 +71,26 @@
 _VOID      _EXFUN(tzset,	(_VOID));
 _VOID      _EXFUN(_tzset_r,	(struct _reent *));
 
+typedef struct __tzrule_struct
+{
+  char ch;
+  int m;
+  int n;
+  int d;
+  int s;
+  time_t change;
+  long offset; /* Match type of _timezone. */
+} __tzrule_type;
+
+typedef struct __tzinfo_struct
+{
+  int __tznorth;
+  int __tzyear;
+  __tzrule_type __tzrule[2];
+} __tzinfo_type;
+
+__tzinfo_type *_EXFUN (__gettzinfo, (_VOID));
+
 /* getdate functions */
 
 #ifdef HAVE_GETDATE
@@ -95,7 +115,7 @@
 #endif /* HAVE_GETDATE */
 
 /* defines for the opengroup specifications Derived from Issue 1 of the SVID.  */
-extern __IMPORT time_t _timezone;
+extern __IMPORT long _timezone;
 extern __IMPORT int _daylight;
 extern __IMPORT char *_tzname[2];
 
@@ -111,7 +131,7 @@
 #endif
 #ifdef timezonevar
 #ifndef timezone
-#define timezone ((long int) _timezone)
+#define timezone _timezone
 #endif
 #else
 char *_EXFUN(timezone, (void));
Index: src/newlib/libc/include/machine/_types.h
diff -u /dev/null src/newlib/libc/include/machine/_types.h:1.2
--- /dev/null	Thu May 12 14:25:16 2005
+++ src/newlib/libc/include/machine/_types.h	Tue Mar 22 18:12:29 2005
@@ -0,0 +1,121 @@
+/*
+ *  $Id: _types.h,v 1.2 2005/03/22 18:12:29 cgf Exp $
+ */
+
+#ifndef _MACHINE__TYPES_H
+#define _MACHINE__TYPES_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+ * Guess on types by examining *_MIN / *_MAX defines.
+ */
+#if defined(__GNUC__) && (__GNUC__ >= 3 ) \
+  && defined(__GNUC_MINOR__) && (__GNUC_MINOR__ > 2 ) 
+/* GCC >= 3.3.0 has __<val>__ implicitly defined. */
+#define __EXP(x) __##x##__
+#else
+/* Fall back to POSIX versions from <limits.h> */
+#define __EXP(x) x
+#include <limits.h>
+#endif
+
+#if __EXP(SCHAR_MAX) == 0x7f
+typedef signed char __int8_t ;
+typedef unsigned char __uint8_t ;
+#define ___int8_t_defined 1
+#endif
+
+#if __EXP(INT_MAX) == 0x7fff
+typedef signed int __int16_t;
+typedef unsigned int __uint16_t;
+#define ___int16_t_defined 1
+#elif __EXP(SHRT_MAX) == 0x7fff
+typedef signed short __int16_t;
+typedef unsigned short __uint16_t;
+#define ___int16_t_defined 1
+#elif __EXP(SCHAR_MAX) == 0x7fff
+typedef signed char __int16_t;
+typedef unsigned char __uint16_t;
+#define ___int16_t_defined 1
+#endif
+
+#if ___int16_t_defined
+typedef __int16_t __int_least16_t;
+typedef __uint16_t __uint_least16_t;
+#define ___int_least16_t_defined 1
+
+#if !___int8_t_defined
+typedef __int16_t __int_least8_t;
+typedef __uint16_t __uint_least8_t;
+#define ___int_least8_t_defined 1
+#endif
+#endif
+
+#if __EXP(INT_MAX) == 0x7fffffffL
+typedef signed int __int32_t;
+typedef unsigned int __uint32_t;
+#define ___int32_t_defined 1
+#elif __EXP(LONG_MAX) == 0x7fffffffL
+typedef signed long __int32_t;
+typedef unsigned long __uint32_t;
+#define ___int32_t_defined 1
+#elif __EXP(SHRT_MAX) == 0x7fffffffL
+typedef signed short __int32_t;
+typedef unsigned short __uint32_t;
+#define ___int32_t_defined 1
+#elif __EXP(SCHAR_MAX) == 0x7fffffffL
+typedef signed char __int32_t;
+typedef unsigned char __uint32_t;
+#define ___int32_t_defined 1
+#endif
+
+#if ___int32_t_defined
+typedef __int32_t __int_least32_t;
+typedef __uint32_t __uint_least32_t;
+#define ___int_least32_t_defined 1
+
+#if !___int8_t_defined
+typedef __int32_t __int_least8_t;
+typedef __uint32_t __uint_least8_t;
+#define ___int_least8_t_defined 1
+#endif
+#if !___int16_t_defined
+typedef __int32_t __int_least16_t;
+typedef __uint32_t __uint_least16_t;
+#define ___int_least16_t_defined 1
+#endif
+#endif
+
+#if __EXP(LONG_MAX) > 0x7fffffff
+typedef signed long __int64_t;
+typedef unsigned long __uint64_t;
+#define ___int64_t_defined 1
+
+/* GCC has __LONG_LONG_MAX__ */
+#elif  defined(__LONG_LONG_MAX__) && (__LONG_LONG_MAX__ > 0x7fffffff)
+typedef signed long long __int64_t;
+typedef unsigned long long __uint64_t;
+#define ___int64_t_defined 1
+
+/* POSIX mandates LLONG_MAX in <limits.h> */
+#elif  defined(LLONG_MAX) && (LLONG_MAX > 0x7fffffff)
+typedef signed long long __int64_t;
+typedef unsigned long long __uint64_t;
+#define ___int64_t_defined 1
+
+#elif  __EXP(INT_MAX) > 0x7fffffff
+typedef signed int __int64_t;
+typedef unsigned int __uint64_t;
+#define ___int64_t_defined 1
+#endif
+
+#undef __EXP
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _MACHINE__TYPES_H */
